package displayTimetables;

import java.awt.*;
import javax.swing.*;

public class TimetableLayout extends JFrame {
	
	private JTextArea ColumnHeadings[] = new JTextArea[5];
	private JTextArea RowHeadings[] = new JTextArea[9];
	private JTextArea slotName[] = new JTextArea[53];
	
	private String [] ColLabels = {"\nMon", "\nTue", "\nWed", "\nThu", "\nFri"};
	private final String [] RowLabels = 
		{"\n09:00", "\n10:00", "\n11:00", "\n12:00", "\n13:00", 
			"\n14:00", "\n15:00", "\n16:00", "\n17:00"};
	
	private Container container; // frame container
	private GridLayout gridLayout; 

	public TimetableLayout(String tableName, String[] tableContents) {
		super("Timetable: " + tableName);
	    gridLayout = new GridLayout( 10, 6, 5, 5 ); // 6 by 10; gaps of 5
	    container = getContentPane(); // get content pane
	    setLayout( gridLayout ); // set JFrame layout
	    
	    //ColumnHeadings = new JTextArea[ColLabels.length]; // create array of JTextArea
	    for (int i = 0; i < ColumnHeadings.length; i++ )
	    	ColumnHeadings[i] = TimetableSlot(ColLabels[i]);
	    //RowHeadings = new JTextArea[RowLabels.length]; // create array of JTextArea
	    for (int i = 0; i < RowHeadings.length; i++ )
	    	RowHeadings[i] = TimetableSlot(RowLabels[i]);

	    JTextArea upperLeft = TimetableSlot(" ");
	    add(upperLeft);
	    for (int i = 0; i < ColumnHeadings.length; i++ )
	    	add(ColumnHeadings[i]); // add column headings
	    
	    int Posn = 0;
	    int Offset = 0;
	    for (int i = 0; i < RowHeadings.length; i++ ) {
	    	add(RowHeadings[i]);
	    	for (int j = 0; j < 5; j++ ) {
		    	slotName[(i*5)+j] = TimetableSlot(tableContents[Posn+Offset]);
			    add(slotName[(i*5)+j]);
			    Offset = Offset + 9;
	    	}
	    	Posn++; Offset = 0;
	    }


	} // end GridLayoutFrame constructor
	
	public JTextArea TimetableSlot(String textArg) {
		JTextArea textArea = new JTextArea(textArg);
		textArea.setEditable(false);
		textArea.setLineWrap(true);
		textArea.setWrapStyleWord(true);
		//textArea.set;
		
		return textArea;
	}
}
