package reformatKeyedData;
/**
 * Classes/Lectures
 */

public class Classes {

  //
  // Fields
  //

	private static int defaultMaxNrClasses = 500;
	private int nrClasses = 0;
	private String[] classNames;
	private String[] classSizes; //Number of students in Class
	private String[] terms; //Which term(s) class is in
  
  //
  // Constructors
  //
  public Classes() {
	  this.nrClasses = 0;
	  this.classNames = new String[defaultMaxNrClasses];
	  this.classSizes = new String[defaultMaxNrClasses];
	  this.terms = new String[defaultMaxNrClasses];
  }
  	
  public Classes(int maxNrClasses) {
	  this.nrClasses = 0;
	  this.classNames = new String[maxNrClasses];
	  this.classSizes = new String[maxNrClasses];
	  this.terms = new String[maxNrClasses];
  }

  //
  // Accessor methods
  //
  /**
   * Get the value of nrClasses
   * @return the value of nrClasses
   */
  public int getNrClasses() {
    return nrClasses;
  }
  
  /**
   * Get the value of classNames
   * @return the value of classNames array
   */
  public String[] getClassNames() {
    return classNames;
  }
  
  /**
   * Get the value of classSize
   * @return the value of classSizes array
   */
  public String[] getClassSizes() {
    return classSizes;
  }
  //
  // Adder methods
  //

  /**
   * Adds new class to arrays
   * @params       className, classSize, term
   */
  public void addClass(String className, String classSize, String term) {
	  if (this.isMember(className) == -1) {
		  this.classNames[nrClasses] = className;
		  this.classSizes[nrClasses] = classSize;
		  this.terms[nrClasses] = term;
		  this.nrClasses++;
	  }
  }
  
  //
  // Other Methods
  //

  /**
   * Checks to see if class is in className array
   * @return       int
   * @param        className
   */
  public int isMember(String className) {
	  for (int posn = 0; posn < this.nrClasses; posn++)
		  if (this.classNames[posn].equals(className))
			  return posn;
	  return -1;
  }
}