package reformatKeyedData;
/************************************************************************
  			Main.java - Copyright ahernp

Here you can write a license for your code, some comments or any other
information you want to have in your generated code. To to this simply
configure the "headings" directory in uml to point to a directory
where you have your heading files.

or you can just replace the contents of this file with your own.
If you want to do this, this file is located at

/usr/share/apps/umbrello/headings/heading.java

-->Code Generators searches for heading files based on the file extension
   i.e. it will look for a file name ending in ".h" to include in C++ header
   files, and for a file name ending in ".java" to include in all generated
   java code.
   If you name the file "heading.<extension>", Code Generator will always
   choose this file even if there are other files with the same extension in the
   directory. If you name the file something else, it must be the only one with that
   extension in the directory to guarantee that Code Generator will choose it.

you can use variables in your heading files which are replaced at generation
time. possible variables are : author, date, time, filename and filepath.
just write %variable_name%

This file was generated on %date% at %time%
The original location of this file is /home/ahernp/documents/MSc/CS5001 Project/uml-generated-code/Main.java
**************************************************************************/

import java.io.*;

public class Main {
	//Constants
	private static final int DAYLENGTH = 9; //Number of working hours in a day (9-5)
	private static final String[] WEEKDAYS = {"Mon", "Tue", "Wed", "Thur", "Fri"};
	private static final String[] CLASSSUFFIX = {"a", "b", "c", "d", "e", "f", "g", "h", "i"};
	//Keyed data
	private static RelatedItems modulesInCourse = new RelatedItems();
    private static RelatedItems coursesInGroup = new RelatedItems();
    private static RelatedItems modulesTaught = new RelatedItems();
    private static Modules modules = new Modules();
    private static Rooms rooms = new Rooms();
    private static KeyedClasses fixedClasses = new KeyedClasses();
    private static KeyedClasses knownClasses = new KeyedClasses();
    private static PreferredTimes preferredTimes = new PreferredTimes();
    //Derived data
    private static Modules derivedModules = new Modules();
    private static DerivedClasses classes = new DerivedClasses();
    private static RelatedItems classesInModule = new RelatedItems();
    private static RelatedItems classesInGroup = new RelatedItems();
    private static RelatedItems lecturersForModule = new RelatedItems();

    private static String [] nextItems = new String[50];

	public static void main(String[] args) {

		String InputFile = args[0];
		String OutputFile = args[1];
        //String InputFile = "Z:\\MSc\\CS5001 Project\\prototype2\\dataInput.csv";
        //String OutputFile = "Z:\\MSc\\CS5001 Project\\prototype2\\generated.dat";
		
		System.out.println("University Timetabling with OPL Studio");
		System.out.println("Generating data: Inputfile is " + InputFile);
		System.out.println("                 Outputfile is " + OutputFile);

	    try {
		    FileOutputStream outFile = new FileOutputStream(OutputFile);
		    PrintStream output = new PrintStream(outFile);
	        BufferedReader in = new BufferedReader(new FileReader(InputFile));
	        String nextLine;
	        
	        //Read in and parse keyed data
	        while ((nextLine = in.readLine()) != null) {
		        nextItems = getDataItems(nextLine);
		        decodeDataItems();
	        } //while
	        in.close();

	        //Derive Additional data/relationships
	        deriveMoreData();
	        
	        //Write out reformatted data
	        writeReformattedData(output);

	        output.close();
	        outFile.close();
			System.out.println("Reformatted data written to " + OutputFile);

	    
	    } catch (IOException e) {System.out.println("IO exception" + e);} // end catch
	}
	
	public static String[] getDataItems(String arg) {
				
		String[] DataItems = new String[50];
		arg = arg.replace("\"", ""); //remove double quotes
		DataItems = arg.split(","); //split on comma delimiters
			
		return DataItems;		
	}

	/**
	 * Parse data input input
	 *
	 */
	public static void decodeDataItems() {
    	
    	if (nextItems[0].equals("ModulesInCourse")) {
    		modulesInCourse.addItem(nextItems[1]);
    		for (int i = 2; i < nextItems.length; i++)
    			modulesInCourse.addRelatedItem(nextItems[1],nextItems[i]);
    	}
    	else if (nextItems[0].equals("CoursesInGroup")) {
    		coursesInGroup.addItem(nextItems[1]);
    		for (int i = 2; i < nextItems.length; i++)
    			coursesInGroup.addRelatedItem(nextItems[1],nextItems[i]);
    	}
    	else if (nextItems[0].equals("ModulesTaught")) {
    		modulesTaught.addItem(nextItems[1]);
    		for (int i = 2; i < nextItems.length; i++)
    			modulesTaught.addRelatedItem(nextItems[1],nextItems[i]);
    	}
    	else if (nextItems[0].equals("Module")) {
    		modules.addModule(nextItems[1],
    				Integer.parseInt(nextItems[2]),//Number of Lectures
    				Integer.parseInt(nextItems[3]),//Number of Terms
    				nextItems[4] //Number of Students
    		);
    	}
    	else if (nextItems[0].equals("Room")) {
    		rooms.addRoom(nextItems[1],
    				nextItems[2],    //Number of Students
    				nextItems[3],//Presence of projector
    				nextItems[4] //Presence of PCs
    				);
    	}
    	else if (nextItems[0].equals("FixedClass")) {
    		fixedClasses.addKeyedClass(nextItems[1],
    				DayOfWeek.valueOf(nextItems[2]),   //Day of Week
    				HourOfDay.valueOf(nextItems[3]),   //Hour of Day
    				nextItems[4],                      //Term
    				nextItems[5],                      //Room
    				nextItems[6]                       //Lecturer
    				);
    	}
    	else if (nextItems[0].equals("KnownClass")) {
    		knownClasses.addKeyedClass(nextItems[1],
    				DayOfWeek.valueOf(nextItems[2]),   //Day of Week
    				HourOfDay.valueOf(nextItems[3]),   //Hour of Day
    				nextItems[4],                      //Term
    				nextItems[5],                      //Room
    				nextItems[6]                       //Lecturer
    		);
    	}
    	else if (nextItems[0].equals("PreferredTimes")) {
    		preferredTimes.addPreferredTimes( 
    				DayOfWeek.valueOf(nextItems[1]),   //Day of Week
    				nextItems[2],      //Hour1 of Day
    				nextItems[3],      //Hour2 of Day
    				nextItems[4],      //Hour3 of Day
    				nextItems[5],      //Hour4 of Day
    				nextItems[6],      //Hour5 of Day
    				nextItems[7],      //Hour6 of Day
    				nextItems[8],      //Hour7 of Day
    				nextItems[9],      //Hour8 of Day
    				nextItems[10]);    //Hour8 of Day
    	}
	}
	/**
	 * Derive data from that keyed. For example from the lsit of lecturer
	 * preferences, work out which lecturers are available to teach each module.
	 *
	 */
    public static void deriveMoreData() {
    	int modulePosn, coursePosn;
    	String groupName, courseName, moduleName, className, lecturerName, roomName;
    	//Derive room, module and lecturer names from fixed classes
    	for (int f = 0; f < fixedClasses.getNrKeyedClasses(); f++) {
    		moduleName = fixedClasses.getKeyedClassName(f);
    		moduleName = moduleName.substring(0, moduleName.length()-1);
    		if (modules.isMember(moduleName) == -1) {
    			modulePosn = derivedModules.isMember(moduleName);
    			if (modulePosn == -1) 
    				derivedModules.addModule(moduleName,
    						1,//Number of Lectures
    						1,//Number of Terms
    						"0" //Number of Students
    				);
    			else
    				derivedModules.setNrLectures(modulePosn,
    						derivedModules.getNrLectures(modulePosn)+1);
    		}
    		lecturerName = fixedClasses.getKeyedClassLecturer(f);
    		modulesTaught.addItem(lecturerName);
    		modulesTaught.addRelatedItem(lecturerName, moduleName);
    		roomName = fixedClasses.getKeyedClassRoom(f);
    		rooms.addRoom(roomName,//Name of Room
    				"0",//Size of Room
    				"0",//Projector
    				"0");//PCs
    	}
    	for (int f = 0; f < derivedModules.getNrModules(); f++) 
    		modules.addModule(derivedModules.getModuleName(f), 
    				derivedModules.getNrLectures(f), 
    				derivedModules.getNrTerms(f), 
    				derivedModules.getNrStudents(f));
    	//Check at least one lecturer is available for each module
    	boolean moduleFound;
    	for (int mod = 0; mod < modules.getNrModules(); mod++) {
    		moduleName = modules.getModuleName(mod);
    		moduleFound = false;
    		for (int l = 0; l < modulesTaught.getNrItems(); l++) {
    			if (modulesTaught.isMemberRelated(l, moduleName) != -1) {
    				moduleFound = true;
    				break;
    			}
    		}
    		if (moduleFound == false)
    			System.out.println("Error: No lecturers found for " + moduleName);
    	}
    	//Remove unused module names from lecturer preferences
    	int nrExtraModules = 0;
    	String [] extraModuleNames = new String [200];
    	//Identify unused module names
    	for (int l = 0; l < modulesTaught.getNrItems(); l++) {
    		for (int mod = 0; mod < modulesTaught.getNrRelatedItems(l); mod++) {
    			moduleName = modulesTaught.getRelatedItem(l, mod);
    			if (modules.isMember(moduleName) == -1) {
    				extraModuleNames[nrExtraModules] = moduleName;
    				nrExtraModules++;
    			}
    		}
    	}
    	//Delete extra modules from lecture preferences
    	for (int mod = 0; mod < nrExtraModules; mod++) 
    		modulesTaught.delRelatedItem(extraModuleNames[mod]);
    	//Derive lecturers availabe for each module from lecturer preferences
    	for (int l = 0; l < modulesTaught.getNrItems(); l++) {
    		lecturerName = modulesTaught.getItemName(l);
    		for (int mod = 0; mod < modulesTaught.getNrRelatedItems(l); mod++) {
    			moduleName = modulesTaught.getRelatedItem(l, mod);
    			if (lecturersForModule.isMember(moduleName) == -1)
    				lecturersForModule.addItem(moduleName);
    			lecturersForModule.addRelatedItem(moduleName, lecturerName);	
    		}
    	}
    	
    	//Build entries for each class/lecture
    	for (int cg = 0; cg < coursesInGroup.getNrItems(); cg++) {
    		//for each group of courses (i.e. timetable)
    		groupName = coursesInGroup.getItemName(cg);
    		classesInGroup.addItem(groupName);
    		for (int cou = 0; cou < coursesInGroup.getNrRelatedItems(cg); cou++) {
    			//for each course in a group
    			courseName = coursesInGroup.getRelatedItem(cg,cou);
    			coursePosn = modulesInCourse.isMember(courseName); 
    			if (coursePosn == -1)
    				System.out.println("Modules not found for " + courseName);
    			for (int mod = 0; mod < modulesInCourse.getNrRelatedItems(courseName); mod++) {
    				//for each module in a course
    				moduleName = modulesInCourse.getRelatedItem(coursePosn,mod);
    				classesInModule.addItem(moduleName);
    				modulePosn = modules.isMember(moduleName);
    				if (modulePosn == -1)
    					System.out.println("Module data not found for " + moduleName);
    				else
    					for (int cls = 0; cls < modules.getNrLectures(modulePosn); cls++) {
    						//build class entries
    						className = moduleName + CLASSSUFFIX[cls];
    						classesInModule.addRelatedItem(moduleName, className);
    						classesInGroup.addRelatedItem(groupName, className);
    						classes.addDerivedClass(className, modules.getNrStudents(modulePosn));
    					}
    			} //modules		
    		} //course
    	} //group
    }
	/**
	 * Write out data in the format required by OPL Studio.
	 *
	 */
    public static void writeReformattedData(PrintStream output) {
    	String nextData;

    	System.out.println("Writing out reformatted data");
    	output.println("dayLength = " + DAYLENGTH + ";");
    	output.println("weekLength = " + DAYLENGTH*WEEKDAYS.length + ";");
    	output.println("terms = {First, Second, Both};");
    	output.println("nrFixedClasses = " + fixedClasses.getNrKeyedClasses() + ";");
    	output.println("nrKnownClasses = " + knownClasses.getNrKeyedClasses() + ";");
    	
    	nextData = "";
    	for (int i = 0; i < WEEKDAYS.length; i++) {
    		nextData = nextData + "\"" + WEEKDAYS[i] + "\",";
    	}
    	nextData = nextData.substring(0,nextData.length()-1);
    	output.println("dayNames = [" + nextData + "];");
    	OutputSet.OutputSetItem("dayOfWeek", WEEKDAYS.length, WEEKDAYS, output);
    	OutputSet.Output2DArrayItem("preferredTimes", preferredTimes.getPreferredTimes(), output);
    	
    	OutputSet.OutputSetItem("CourseGroups", coursesInGroup.getNrItems(), 
    			coursesInGroup.getItemNames(), output);
    	//OutputSet.OutputSetItem("Courses", modulesInCourse.getNrItems(), 
    	//		modulesInCourse.getItemNames(), output);
    	OutputSet.OutputSetItem("Modules", modules.getNrModules(), 
    			modules.getModuleNames(), output);
    	OutputSet.OutputSetItem("Classes", classes.getNrClasses(), 
    			classes.getClassNames(), output);
    	OutputSet.OutputSetItem("Lecturers", modulesTaught.getNrItems(), 
    			modulesTaught.getItemNames(), output);
    	OutputSet.OutputSetItem("Rooms", rooms.getNrRooms(), 
    			rooms.getRoomNames(), output);
    	//OutputSet.Output2DSetItem("CoursesInGroup", coursesInGroup.getNrItems(),
    	//		coursesInGroup.getNrRelatedItems(), coursesInGroup.getItemNames(),
    	//		coursesInGroup.getRelatedItemNames(), output);
    	OutputSet.Output2DSetItem("ClassesInModule", classesInModule.getNrItems(),
    			classesInModule.getNrRelatedItems(), classesInModule.getItemNames(),
    			classesInModule.getRelatedItemNames(), output);
    	OutputSet.Output2DSetItem("ClassesInGroup", classesInGroup.getNrItems(),
    			classesInGroup.getNrRelatedItems(), classesInGroup.getItemNames(),
    			classesInGroup.getRelatedItemNames(), output);
    	//OutputSet.Output2DSetItem("ModulesInCourse", modulesInCourse.getNrItems(),
    	//		modulesInCourse.getNrRelatedItems(), modulesInCourse.getItemNames(),
    	//		modulesInCourse.getRelatedItemNames(), output);
    	OutputSet.Output2DSetItem("ModulesTaught", modulesTaught.getNrItems(),
    			modulesTaught.getNrRelatedItems(), modulesTaught.getItemNames(),
    			modulesTaught.getRelatedItemNames(), output);
    	OutputSet.Output2DSetItem("LecturersForModule", lecturersForModule.getNrItems(),
    			lecturersForModule.getNrRelatedItems(), lecturersForModule.getItemNames(),
    			lecturersForModule.getRelatedItemNames(), output);
    	OutputSet.Output1DArrayItem("RoomSize", rooms.getNrRooms(),
    			rooms.getRoomNames(), rooms.getRoomSizes(), output);
    	OutputSet.Output1DArrayItem("ClassSize", classes.getNrClasses(),
    			classes.getClassNames(), classes.getClassSizes(), output);
    	OutputSet.OutputStructItem("FixedClass", fixedClasses.getNrKeyedClasses(), 
    			fixedClasses.getKeyedClassStructure(), output);
    	OutputSet.OutputStructItem("KnownClass", knownClasses.getNrKeyedClasses(), 
    			knownClasses.getKeyedClassStructure(), output);
    }
}
