package reformatKeyedData;
/**
 * Class Modules
 */

public class Modules {

  //
  // Fields
  //

	private static int defaultMaxNrModules = 100;
	private int nrModules = 0;
	private String[] moduleNames;
	private int[] nrLectures; //Number of Lectures per week
	private int[] nrTerms; //Number of Terms Module is in
	private String[] nrStudents; //Number of Students taking Module
  
  //
  // Constructors
  //
  public Modules () {
	  this.nrModules = 0;
	  this.moduleNames = new String[defaultMaxNrModules];
	  this.nrLectures = new int[defaultMaxNrModules];
	  this.nrTerms = new int[defaultMaxNrModules];
	  this.nrStudents = new String[defaultMaxNrModules];
  }
  	
  public Modules (int maxNrModules) {
	  this.nrModules = 0;
	  this.moduleNames = new String[maxNrModules];
	  this.nrLectures = new int[maxNrModules];
	  this.nrTerms = new int[maxNrModules];
	  this.nrStudents = new String[maxNrModules];
  }
	  	
  //
  // Methods
  //


  //
  // Accessor methods
  //
  
  /**
   * Get the names of the modules
   * @return an array of all module names
   */
  public String[] getModuleNames() {
	  return this.moduleNames;
  }

  /**
   * Get the value of an indexed item
   * @return the number of lectures
   */
  public String getModuleName(int itemIndex) {
	  return this.moduleNames[itemIndex];
  }
  
  /**
   * Get the number of modules
   * @return nrModules
   */
  public int getNrModules() {
	  return this.nrModules;
  }
  
  /**
   * Get the value of an indexed item
   * @return the number of lectures
   */
  public int getNrLectures(int itemIndex) {
	  return this.nrLectures[itemIndex];
  }

  /**
   * Set the value of an indexed item number of lectures
   */
  public void setNrLectures(int itemIndex, int nr) {
	  this.nrLectures[itemIndex] = nr;
  }
  
  /**
   * Get the value of an itemName
   * @return the number of lectures
   */
  public int getNrLectures(String itemName) {
	  int posn = isMember(itemName);
	  return this.nrLectures[posn];
  }

  /**
   * Get the value of an indexed item
   * @return the number of students
   */
  public String getNrStudents(int itemIndex) {
	  return this.nrStudents[itemIndex];
  }
  
  /**
   * Get the value of an indexed item
   * @return the number of students
   */
  public int getNrTerms(int itemIndex) {
	  return this.nrTerms[itemIndex];
  }
  
  //
  // Other methods
  //

  /**
   * Adds new module to arrays
   * @params       moduleName, nrLectures, nrTerms, nrStudents
   */
  public void addModule(String moduleName, int nrLectures, int nrTerms, String nrStudents) {
	  if (this.isMember(moduleName) == -1) {
		  this.moduleNames[nrModules] = moduleName;
		  this.nrLectures[nrModules] = nrLectures;
		  this.nrTerms[nrModules] = nrTerms;
		  this.nrStudents[nrModules] = nrStudents;
		  this.nrModules++;
	  }
  }


  /**
   * Checks to see if module is in moduleName array
   * @return       int
   * @param        moduleName
   */
  public int isMember(String moduleName) {
	  for (int posn = 0; posn < this.nrModules; posn++)
		  if (this.moduleNames[posn].equals(moduleName))
			  return posn;
	  return -1;
  }
}
