package reformatKeyedData;

import java.io.PrintStream;

/**
 * Class OutputSet
 * Format the various types of output (sets, arrays, etc.) and write to a PrintStream
 */
public class OutputSet {
	
	/**
	 * Write set elements separated by commas and between {} 
	 * @param SetName name of set of data to be written
	 * @param SetSize number of elements in set
	 * @param SetElements array of set elements
	 * @param output PrintStream to write to
	 */
	public static void OutputSetItem(String SetName,
									 int SetSize, 
									 String[] SetElements,
									 PrintStream output) {
		output.println(SetName + " = {");
		for (int i = 0; i < SetSize; i++) {
			if (i == SetSize-1)
				output.println("   " + SetElements[i]);
			else	
				output.println("   " + SetElements[i] + ",");
		}
		output.println("   };");
	}
	
	public static void OutputStructItem(String StructName,
			 int nrItems,
			 String[][] StructElements,
			 PrintStream output) {

		String nextData;
		
		output.println(StructName + " = [");
		for (int i = 0; i < nrItems; i++) {
			nextData = "< ";
			for (int j = 0; j < StructElements[i].length; j++) {
				nextData = nextData + StructElements[i][j] + ",";
			}
			nextData = nextData.substring(0,nextData.length()-1)+">,";
			if (i == nrItems-1) {
				nextData = nextData.substring(0,nextData.length()-1);
			}
			output.println("   " + nextData);
		}
		output.println("   ];");
	}

	public static void Output2DArrayItem(String SetName,
			 String[][] SetElements,
			 PrintStream output) {

		String nextData;
		
		output.println(SetName + " = [");
		for (int i = 0; i < SetElements.length; i++) {
			nextData = "";
			for (int j = 0; j < SetElements[i].length; j++) {
				nextData = nextData + SetElements[i][j] + ",";
			}
			//nextData = nextData.substring(0,nextData.length()-1)+"],";
			if (i == SetElements.length-1) {
				nextData = nextData.substring(0,nextData.length()-1);
			}
			output.println("   " + nextData);
		}
		output.println("   ];");
	}

	public static void Output1DArrayItem(String ArrayName,
			 int ArraySize,
			 String[] ArrayLabel,
			 String[] ArrayElements,
			 PrintStream output) {

		output.println(ArrayName + " = #[");
        for (int i = 0; i < ArraySize; i++) {
	        if (i == ArraySize-1) 
	        	output.println("   " + ArrayLabel[i] + ": " + ArrayElements[i]);
	        else
	        	output.println("   " + ArrayLabel[i] + ": " + ArrayElements[i] + ",");
        }
        output.println("   ]#;");
	}

	public static void Output2DSetItem(String SetName,
			 int nrSets,
			 int[] SetSize,
			 String[] SetLabels,
			 String[][] SetElements,
			 PrintStream output) {

		String nextData;
		
        output.println(SetName + " = #[");
        for (int i = 0; i < nrSets; i++) {
	        nextData = "";
	        for (int j = 0; j < SetSize[i]; j++) {
	        	nextData = nextData + SetElements[i][j] + ",";
	        }
	        nextData = nextData.substring(0,nextData.length()-1);
	        if (i == nrSets-1) 
	        	output.println("   " + SetLabels[i] + ": {" + nextData + "}");
	        else
	        	output.println("   " + SetLabels[i] + ": {" + nextData + "},");
        }
        output.println("   ]#;");
		
	}

}
