package reformatKeyedData;
/************************************************************************
  			RelatedItems.java - Copyright ahernp

Here you can write a license for your code, some comments or any other
information you want to have in your generated code. To to this simply
configure the "headings" directory in uml to point to a directory
where you have your heading files.

or you can just replace the contents of this file with your own.
If you want to do this, this file is located at

/usr/share/apps/umbrello/headings/heading.java

-->Code Generators searches for heading files based on the file extension
   i.e. it will look for a file name ending in ".h" to include in C++ header
   files, and for a file name ending in ".java" to include in all generated
   java code.
   If you name the file "heading.<extension>", Code Generator will always
   choose this file even if there are other files with the same extension in the
   directory. If you name the file something else, it must be the only one with that
   extension in the directory to guarantee that Code Generator will choose it.

you can use variables in your heading files which are replaced at generation
time. possible variables are : author, date, time, filename and filepath.
just write %variable_name%

This file was generated on %date% at %time%
The original location of this file is /home/ahernp/documents/MSc/CS5001 Project/uml-generated-code/RelatedItems.java
**************************************************************************/



/**
 * Class RelatedItems
 */
public class RelatedItems {

  //
  // Fields
  //

  private static int defaultMaxNrItems = 100;
  private static int defaultMaxNrRelated = 100;
  private int nrItems = 0;
  private String[] itemNames;
  private int[] nrRelatedItems;
  private String[][] relatedItemNames;
  
  //
  // Constructors
  //
  public RelatedItems() {
	  this.nrItems = 0;
	  this.itemNames = new String[defaultMaxNrItems];
	  this.nrRelatedItems = new int[defaultMaxNrItems];
	  this.relatedItemNames = new String[defaultMaxNrItems][defaultMaxNrRelated];
  }
  	
  public RelatedItems(int maxNrItems, int maxNrRelated) {
	  this.nrItems = 0;
	  this.itemNames = new String[maxNrItems];
	  this.nrRelatedItems = new int[maxNrItems];
	  this.relatedItemNames = new String[maxNrItems][maxNrRelated];
  }
  
  //
  // Accessor Methods
  //
	  	
  /**
   * Get the value of nrItems
   * @return the value of nrItems
   */
  public int getNrItems() {
	  return this.nrItems;
  }

  /**
   * Get the value of an itemName
   * @return the value of an entry in the itemNames array
   */
  public String getItemName(int itemIndex) {
	  return this.itemNames[itemIndex];
  }

  /**
   * Get the value of itemNames
   * @return the value of itemNames array
   */
  public String[] getItemNames() {
	  return this.itemNames;
  }

  /**
   * Get the number of related items
   * @return the value of nrRelatedItems
   */
  public int getNrRelatedItems(int itemIndex) {
	  return this.nrRelatedItems[itemIndex];
  }

  /**
   * Get the value of nrRelatedItems
   * @return the value of nrRelatedItems
   */
  public int[] getNrRelatedItems() {
	  return this.nrRelatedItems;
  }

  /**
   * Get the value of relatedItemNames
   * @return the value of relatedItemNames
   */
  public String[][] getRelatedItemNames() {
	  return this.relatedItemNames;
  }
  
  /**
   * Returns relatedItem
   * @return       String
   * @param        itemIndex
   * @param        relatedItemIndex
   */
  public String getRelatedItem(int itemIndex, int relatedItemIndex) {
	  return this.relatedItemNames[itemIndex][relatedItemIndex];
  }

  /**
   * Returns array of relatedItems
   * @return       String[]
   * @param        itemName
   */
  public String[] getRelatedItems(String itemName) {
	  int posn = isMember(itemName);
	  return this.relatedItemNames[posn];
  }

  /**
   * Returns number of elements in realtedItems array for itemName
   * @return       int
   * @param        itemName
   */
  public int getNrRelatedItems(String itemName) {
	  int posn = isMember(itemName);
	  if (posn == -1)
		  return 0;
	  else
		  return this.nrRelatedItems[posn];
  }

  //
  // Adder methods
  //

  /**
   * Adds new item to array of itemNames
   * @param        itemName
   */
  public void addItem(String itemName) {
	  int posn = isMember(itemName);
	  if (posn == -1) {
		  this.itemNames[nrItems] = itemName;
		  this.nrItems++;
	  }
  }

  /**
   * Adds relatedItemName to the array of related items for itemName
   * @param        itemName
   * @param        relatedItemName
   */
  public void addRelatedItem(String itemName, String relatedItemName) {
	  int posn = isMember(itemName);
	  if (posn != -1) 
		  if (isMemberRelated(posn, relatedItemName) == -1) {
			  this.relatedItemNames[posn][this.nrRelatedItems[posn]] = relatedItemName;
			  this.nrRelatedItems[posn]++;
		  }
  }
  
  //
  // Other Methods
  //

  /**
   * Remove relatedItemName from the array of related items 
   * @param        relatedItemName
   */
  public void delRelatedItem(String relatedItemName) {
	  int posn;
 	  for (int i = 0; i < nrItems; i++) {
 		  posn = isMemberRelated(i, relatedItemName);
 		  if (posn != -1) {
 			  for (int r = posn; r < nrRelatedItems[i]; r++)
 				  this.relatedItemNames[i][r] = this.relatedItemNames[i][r+1];
 			  nrRelatedItems[i]--;
 		  }
 		  //If item has no related items left then delete it also
 		  if (nrRelatedItems[i] == 0) 
 			  delItem(i);
	  }
  }

  /**
   * Remove itemName from the array of itemNames
   * @param        itemIndex
   */
  public void delItem(int itemIndex) {
	  for (int i = itemIndex; i < nrItems; i++) {
		  this.itemNames[i] = this.itemNames[i+1];
		  this.nrRelatedItems[i] = this.nrRelatedItems[i+1];
		  this.relatedItemNames[i] = this.relatedItemNames[i+1];
	  }
	  nrItems--;
  }

  /**
   * Checks to see if item is in itemName array
   * @return       int
   * @param        itemName
   */
  public int isMember(String itemName) {
	  for (int posn = 0; posn < this.nrItems; posn++)
		  if (this.itemNames[posn].equals(itemName))
			  return posn;
	  return -1;
  }
  
  /**
   * Checks to see if realtedItem is in particular relatedItemNames array
   * @return       int
   * @param        itemIndex, relatedItemName
   */
  public int isMemberRelated(int itemIndex, String relatedItemName) {
	  for (int posn = 0; posn < this.nrRelatedItems[itemIndex]; posn++)
		  if (this.relatedItemNames[itemIndex][posn].equals(relatedItemName))
			  return posn;
	  return -1;
  }
  
}
